disp(' ');
disp('  enforced_displacement.m  ver 1.6  October 29, 2013 ');
disp('  by Tom Irvine ');
%
%
clear Mdd;  % driven
clear Mdf;
clear Mfd;
clear Mff;  % free
%
clear Mdw;
clear Mwd;
clear Mww;
%
clear MP;
clear MT;
%
clear Kdd;  
clear Kdf;
clear Kfd;
clear Kff;
%
clear invKff;
%
clear Kww;
%
clear KP;
clear KT;
%
clear n;
clear na;
clear nv;
clear nd;
%
clear m;
clear k;
%
clear TT;
clear T1;
clear T2;
%
clear I;
clear Idd;
clear Iff;
%
clear damp;
clear ea;
clear f;
clear ngw;
%
clear ttend;
clear ttstart;
%
disp(' ');
disp(' Enter the units system ');
disp(' 1=English  2=metric ');
iu=input(' ');
%
disp(' Assume symmetric mass and stiffness matrices. ');
%
mass_scale=1;
%
if(iu==1)
     disp(' Select input mass unit ');
     disp('  1=lbm  2=lbf sec^2/in  ');
     imu=input(' ');
     if(imu==1)
         mass_scale=386;
     end
else
    disp(' mass unit = kg ');
end
%
if(iu==1)
    disp(' stiffness unit = lbf/in ');
else
    disp(' stiffness unit = N/m ');
end
%
disp(' ');
disp(' Select file input method ');
disp('   1=file preloaded into Matlab ');
disp('   2=Excel file ');
file_choice = input('');
%
disp(' ');
disp(' Mass Matrix ');
%
if(file_choice==1)
        m = input(' Enter the matrix name:  ');
end
if(file_choice==2)
        [filename, pathname] = uigetfile('*.*');
        xfile = fullfile(pathname, filename);
%
        m = xlsread(xfile);
%
end
%
m=m/mass_scale;
%
mass=m;
num=max(size(m));
%
disp(' ');
disp(' Stiffness Matrix ');
%
if(file_choice==1)
        k = input(' Enter the matrix name:  ');
end
if(file_choice==2)
        [filename, pathname] = uigetfile('*.*');
        xfile = fullfile(pathname, filename);
%
        k = xlsread(xfile);
%
end
stiff=k;
%
disp(' Input Matrices ');
mass
stiff
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
disp(' Select modal damping input method ');
disp('  1=uniform damping for all modes ');
disp('  2=damping vector ');
idm=input(' ');
%
disp(' ');
if(idm==1)
   disp(' Enter damping ratio ');
   dampr=input(' ');
   damp(1:num)=dampr;
else
   disp(' Modal Damping Vector ');
%
   if(file_choice==1)
        damp = input(' Enter the vector:  ');
   end
   if(file_choice==2)
        [filename, pathname] = uigetfile('*.*');
        xfile = fullfile(pathname, filename);
%        
        damp = xlsread(xfile);
%         
   end
end
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sz=size(mass);
dof=(sz(1));
num=dof;
%
out1=sprintf('\n number of dofs =%d \n',num);
disp(out1);
%
disp(' ');
disp(' Enter the starting time (sec) ');
tstart=input(' ');
disp(' ');
disp(' Enter the end time (sec) ');
tend=input(' ');
disp(' ');
disp(' Enter the sample rate (samples/sec)');
sr=input(' ');
dt=1/sr;
nt=1+round((tend-tstart)/dt);
%
t =  linspace(tstart,tend,nt);
t=t';
%
nkk=4;
if(num<nkk)nkk=num;end
disp(' ');
out1=sprintf(' Enter the number of dofs with enforced displacement. (maximum = %d) ',nkk);
disp(out1)
%
nem=input(' ');
if(nem>4)nem=4;end
%
nff=num-nem;
%
disp(' ');
disp(' Each input file must have two columns: time & displacement ');
disp(' ');
%
clear daccel;
clear dvelox;
clear ddisp;
%
for(ijk=1:nem)
    if(ijk==1)disp(' Enter the first dof  ');end
    if(ijk==2)disp(' Enter the second dof ');end
    if(ijk==3)disp(' Enter the third dof  ');end
    if(ijk==4)disp(' Enter the fourth dof ');end
    ea(ijk)=input(' ');
%    
    disp(' Enter the applied displacement input matrix name for this dof.   ')    
    clear FI;
    clear yi;
    clear max;
    clear L;   
    FI=input(''); 
    L=length(FI(:,1));
    jmin=1;
    for(i=1:nt)  
        f(i,ijk)=0;
        for(j=jmin:L)
            if(t(i)==FI(j,1))
                f(i,ijk)=FI(j,2);
                jmin=j;
                break;
            end
            if(j>=2 && FI(j-1,1) < t(i) && t(i) < FI(j,1) )
                    l=FI(j,1)-FI(j-1,1);
                    x=t(i)-FI(j-1,1);
                    c2=x/l;
                    c1=1-c2;
                    f(i,ijk)=c1*FI(j-1,2)+ c2*FI(j,2);
                    jmin=j;
                break;
            end
        end
    end
%
    ddisp(:,ijk)=f(:,ijk);
% 
%%%
end
%
%  Track changes
%
ijk=nem+1;
ngw=zeros(num,1);
ngw(1:nem)=ea;
for(i=1:num)
    iflag=0;
    for(nv=1:nem)
      if(i==ea(nv))
          iflag=1;
      end
    end
    if(iflag==0)
        ngw(ijk)=i;
        ijk=ijk+1;
    end
end
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
disp(' ');
disp(' Display partitioned matrices?  1=yes 2=no ');
dtype=input(' ');
%
etype=2;  % enforced displacement
[TT,T1,T2,Mwd,Mww,Kwd,Kww]=enforced_partition_matrices(num,ea,mass,stiff,etype,dtype);
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%
[fn,omega,ModeShapes,MST]=Generalized_Eigen(Kww,Mww,1);
%
omegan=omega;
%
clear r;
clear part;
clear ModalMass;
%
r=ones(nff,1);
%
part = MST*Mww*r;
%
disp(' Participation Factors  ');
part
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Modal Transient
%
clear omegad;
for i=1:nff
    omegad(i)=omegan(i)*sqrt(1-damp(i)^2);
end
%
clear Q;
Q=ModeShapes;
QT=Q';
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  displacement
%
d=zeros(nt,nff);
%
clear forig;
forig=f;
clear f;
f=(Kwd*forig')';
%
n=max(size(Q));
%
num_modes=n;
%
FP=zeros(num_modes,nt);
%
for i=1:nt
    t(i)=(i-1)*dt; 
    ff=f(i,:);
    FP(:,i)=-QT*ff';    
end    
%
nx=zeros(nt,num_modes);
%
[a1,a2,df1,df2,df3,vf1,vf2,vf3,af1,af2,af3]=...
              ramp_invariant_filter_coefficients(num_modes,omegan,damp,dt);
%
disp(' begin digital filtering ');
%
for j=1:num_modes
%
    amodal=FP(j,:);
%
%  displacement
%
    d_forward=[   df1(j),  df2(j), df3(j) ];
    d_back   =[     1, -a1(j), -a2(j) ];
    d_resp=filter(d_forward,d_back,amodal); 
    nx(:,j)=d_resp;  % displacement
%    
end
%
clear d_resp;
clear v_resp;
clear a_resp;
%
Q=Q(:,1:num_modes);
%
disp(' Calculate d');
sz=size(Q);
d=zeros(nt,sz(1));
for i=1:nt
      d(i,:)=(Q*(nx(i,:))')';  
end
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
clear d_save;
d_save=d;
%
%    Transformation back to xd xf
%
clear dT;
%
%%    dT=TT*d';
%
sz=size(ddisp);
if(sz(1)>sz(2))ddisp=ddisp';end
sz=size(d);
if(sz(1)>sz(2))d=d';end
dT=T1*ddisp + T2*d;
%
%  Put in original order
%
clear ZdT;
%
sz=size(forig);
if(sz(1)>sz(2))forig=forig';end
%
sz=size(dT);
if(sz(1)>sz(2))dT=dT';end
%
ZdT=[ forig ; dT ];
%
clear d;   
clear v;
clear acc;
d=zeros(nt,num);
v=zeros(nt,num);
acc=zeros(nt,num);
%
for i=1:num
   for j=1:nt
        d(j,ngw(i))=  (ZdT(i,j));        
   end
     [v(:,i)]=differentiate_function(d(:,i),dt);
   [acc(:,i)]=differentiate_function(v(:,i),dt);   
end
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  Currently setup for 2 to 5 masses
%
if(num==2)
    figure(1);
    plot(t,d(:,1),t,d(:,2));
    legend ('dof 1','dof  2',2);   
end
if(num==3)
    figure(1);
    plot(t,d(:,1),t,d(:,2),t,d(:,3));
    legend ('dof  1','dof  2','dof  3',3);   
end
if(num==4)
    figure(1);
    plot(t,d(:,1),t,d(:,2),t,d(:,3),t,d(:,4));
    legend ('dof  1','dof  2','dof  3','dof  4',4);   
end
if(num==5)
    figure(1);
    plot(t,d(:,1),t,d(:,2),t,d(:,3),t,d(:,4),t,d(:,5));
    legend ('dof  1','dof  2','dof  3','dof  4','dof  5',5);   
end
if(num>5)
   disp(' ');
   disp(' Enter a dof number for displacement plot ');
   idof=input(' ');
   plot(t,d(:,idof));
end
xlabel('Time(sec)');
title('Displacement');
grid on;
if(iu==1)
    ylabel(' Displacement(in) ');
else
    ylabel(' Displacement(m) ');
end
    h = get(gca, 'title');
    set(h, 'FontName', 'Arial','FontSize',11)
        h = get(gca, 'xlabel');
    set(h, 'FontName', 'Arial','FontSize',11)
         h = get(gca, 'ylabel');
    set(h, 'FontName', 'Arial','FontSize',11)   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if(num==2)
    figure(2);
    plot(t,v(:,1),t,v(:,2));
    legend ('dof 1','dof 2',2);   
end
if(num==3)
    figure(2);
    plot(t,v(:,1),t,v(:,2),t,v(:,3));
    legend ('dof 1','dof 2','dof 3',3);   
end
if(num==4)
    figure(2);
    plot(t,v(:,1),t,v(:,2),t,v(:,3),t,v(:,4));
    legend ('dof 1','dof 2','dof 3','dof 4',4);   
end
if(num==5)
    figure(2);
    plot(t,v(:,1),t,v(:,2),t,v(:,3),t,v(:,4),t,v(:,5));
    legend ('dof 1','dof 2','dof 3','dof 4','dof 5',5);   
end
if(num>5)
   disp(' ');
   disp(' Enter a dof number for velocity plot ');
   idof=input(' ');
   plot(t,v(:,idof));
end
xlabel('Time(sec)');
title('Velocity');
grid on;
if(iu==1)
    ylabel(' Velocity(in/sec) ');
else
    ylabel(' Velocity(m/sec) ');
end
    h = get(gca, 'title');
    set(h, 'FontName', 'Arial','FontSize',11)
        h = get(gca, 'xlabel');
    set(h, 'FontName', 'Arial','FontSize',11)
         h = get(gca, 'ylabel');
    set(h, 'FontName', 'Arial','FontSize',11) 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if(num==2)
    figure(3);
    plot(t,acc(:,1),t,acc(:,2));
    legend ('dof 1','dof 2',2);   
end
if(num==3)
    figure(3);
    plot(t,acc(:,1),t,acc(:,2),t,acc(:,3));
    legend ('dof 1','dof 2','dof 3',3);   
end
if(num==4)
    figure(3);
    plot(t,acc(:,1),t,acc(:,2),t,acc(:,3),t,acc(:,4));
    legend ('dof 1','dof 2','dof 3','dof 4',4);   
end
if(num==5)
    figure(3);
    plot(t,acc(:,1),t,acc(:,2),t,acc(:,3),t,acc(:,4),t,acc(:,5));
    legend ('dof 1','dof 2','dof 3','dof 4','dof 5',5);   
end
if(num>5)
   disp(' ');
   disp(' Enter a dof number for acceleration plot ');
   idof=input(' ');
   plot(t,acc(:,idof));
end
xlabel('Time(sec)');
title('Acceleration');
grid on;
if(iu==1)
    ylabel(' Accel(G) ');
else
    ylabel(' Accel(m/sec^2) ');
end
%
    h = get(gca, 'title');
    set(h, 'FontName', 'Arial','FontSize',11)
        h = get(gca, 'xlabel');
    set(h, 'FontName', 'Arial','FontSize',11)
         h = get(gca, 'ylabel');
    set(h, 'FontName', 'Arial','FontSize',11) 
%